=== debian/changelog ===
hxcfloppyemulator (2.16.13.1-0ddebs2~ubuntu24.04) noble; urgency=medium

  * use of dh-exec to reduce complexity of debian/ files

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Wed, 26 Nov 2025 00:52:05 +0100

hxcfloppyemulator (2.16.13.1-0ddebs1) unstable; urgency=medium

  * New upstream release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Mon, 24 Nov 2025 01:24:17 +0100

hxcfloppyemulator (2.15.2.3-0ddebs2) unstable; urgency=medium

  * Updated to standards-version 4.6.2
  * use debhelper compatibility v13

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Mon, 11 Mar 2024 10:35:19 +0100

hxcfloppyemulator (2.15.2.3-0ddebs1) unstable; urgency=medium

  * New upstream release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 11 Feb 2024 23:30:47 +0100

hxcfloppyemulator (2.14.4.1-0ddebs2) unstable; urgency=medium

  * use xz compression until debian 13 is released

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sat, 22 Apr 2023 16:44:35 +0200

hxcfloppyemulator (2.14.4.1-0ddebs1) unstable; urgency=medium

  * New upstream release.

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Tue, 18 Apr 2023 00:51:47 +0200

hxcfloppyemulator (2.5.8.1-0ddebs1) unstable; urgency=medium

  * New upstream update

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 15 May 2022 17:26:59 +0200

hxcfloppyemulator (2.5.6.6-0ddebs2) unstable; urgency=medium

  * update to standards-version 4.6.0.1
  * make use of debhelper-compat (= 12) dependency, and remove
    debian/compat file
  * avoid use of dh_dwz when compile on buster

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Tue, 05 Apr 2022 23:08:57 +0200

hxcfloppyemulator (2.5.6.6-0ddebs1) unstable; urgency=medium

  * upstream update

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 25 Apr 2021 11:35:10 +0200

hxcfloppyemulator (2.5.2.1-0ddebs1) unstable; urgency=medium

  * upstream update

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 29 Nov 2020 12:00:12 +0100

hxcfloppyemulator (2.4.1.6-0ddebs3) unstable; urgency=medium

  * update for cross-compile

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Tue, 21 Jul 2020 23:02:20 +0200

hxcfloppyemulator (2.4.1.6-0ddebs2) unstable; urgency=medium

  * removed auto-generation of the manual with pandoc, because this command is
    not in distributions that have dropped 32 bits isos
    Manual is still generated by the markdown file, but outside packaging

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Thu, 23 Apr 2020 18:05:42 +0200

hxcfloppyemulator (2.4.1.6-0ddebs1) unstable; urgency=medium

  * Upstream Update
  * rebuild all packages in one

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Tue, 21 Apr 2020 02:05:18 +0200

hxcfloppyemulator (2.1.22.3-0ddebs2) unstable; urgency=medium

  * updated to standards-version 4.5.0

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Mon, 20 Apr 2020 02:55:35 +0200

hxcfloppyemulator (2.1.22.3-0ddebs1) unstable; urgency=medium

  * Upstream update

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Mon, 04 Mar 2019 01:55:07 +0100

hxcfloppyemulator (2.1.11.1-0ddebs2) unstable; urgency=medium

  * Updated to standard version 4.1.4
  * hardening compilation

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 03 Mar 2019 17:31:04 +0100

hxcfloppyemulator (2.1.11.1-0ddebs1) unstable; urgency=medium

  * Updated upstream version
      27 May 2018: HxCFloppyEmulator 2.1.11.1
      Hard-sectored H8D Heathkit raw file Loader & Writer added !

      24 May 2018: HxCFloppyEmulator 2.1.10.1
      Kryoflux Stream Loader (*XX.X.raw) & Stream analyzer : Hard-sectored
       images support and various fixes !
      Kryoflux Stream Loader (*XX.X.raw) : bmpexport.txt config file to generate
       the full stream track graph.
      NSI Northstar raw file Loader & Writer added !

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Wed, 06 Jun 2018 00:06:30 +0200

hxcfloppyemulator (2.1.9.3-0ddebs1) unstable; urgency=medium

  * Initial release

 -- Nicolas HOUDELOT <nicolas@demosdebs.org>  Sun, 03 Jun 2018 22:40:38 +0200
