=== debian/rules ===
#!/usr/bin/make -f

export DEB_CFLAGS_MAINT_APPEND  = -flto
export DEB_CPPFLAGS_MAINT_APPEND  = -flto 
export DEB_LDFLAGS_MAINT_APPEND  = -flto
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export HXCFVERSION := $(shell dpkg-parsechangelog -S Version | cut -d- -f1)

%:
	dh $@ --no-parallel --sourcedirectory=build
