=== debian/watch ===
version=4
opts="compression=xz,repack" \
  https://github.com/jfdelnero/HxCFloppyEmulator/tags .*/HxCFloppyEmulator_V?(\d+)\_(\d+)\_(\d+)\_(\d+)@ARCHIVE_EXT@ \
debian uupdate
